package icommand.platform.nxt;

// !! How to handle fact that if motor is in backwards it goes opposite direction? invertMotors() method?
// Probably will have to reset block tacho or tachocount before each turn.
// !! Might not always be hooked up properly. reverseSpin(boolean) method?
public class SyncMotors {
	
	public Motor left;
	public Motor right;
	boolean inverted;
	boolean sync;

	/**
	 * The Lego firmware only accepts 3 valid combinations for Motors:
	 * A,B
	 * A,C
	 * B,C
	 * PRELIMINARY: Expect poor performance for some commands until things
	 * are improved.
	 * @param left
	 * @param right
	 */
	public SyncMotors(Motor left, Motor right) {
		this.left = left;
		this.right = right;
		inverted = false;
		setSync(true);
//		left.setRegulationMode(icommand.nxtcomm.NXTProtocol.REGULATION_MODE_MOTOR_SYNC);
//		right.setRegulationMode(icommand.nxtcomm.NXTProtocol.REGULATION_MODE_MOTOR_SYNC);
	}
	
	/**
	 * Note: This does not alter the speed realtime. The speed
	 * is changed the next time you call one of the movement methods.
	 * @param speed
	 */
	public void setSpeed(int speed) {
		left.setSpeed(speed);
		right.setSpeed(speed);
	}
	
	public void invertMotors() {
		inverted = !inverted;
	}
	
	public void setSync(boolean sync) {
		if(this.sync != sync) {
			this.sync = sync;

			if(sync) {
				left.setRegulationMode(icommand.nxtcomm.NXTProtocol.REGULATION_MODE_MOTOR_SYNC);
				right.setRegulationMode(icommand.nxtcomm.NXTProtocol.REGULATION_MODE_MOTOR_SYNC);
			}
			else {
				left.setRegulationMode(icommand.nxtcomm.NXTProtocol.REGULATION_MODE_IDLE);
				right.setRegulationMode(icommand.nxtcomm.NXTProtocol.REGULATION_MODE_IDLE);
			}
		}
	}

	public void forward() {
		setSync(true);
		left.resetBlockTacho();
		right.resetBlockTacho();
		left.turnRatio = 0;
		right.turnRatio = 0;
		if(inverted) {
			this.left.backward();
			this.right.backward();
		} else {
			this.left.forward();
			this.right.forward();
		}
	}
	
	public void backward() {
		setSync(true);
		left.resetBlockTacho();
		right.resetBlockTacho();
		left.turnRatio = 0;
		right.turnRatio = 0;
		if(inverted) {
			this.left.forward();
			this.right.forward();
		} else {	
			this.left.backward();
			this.right.backward();
		}
	}
	
	public void left() {
		setSync(false);

		left.resetBlockTacho();
		right.resetBlockTacho();

		this.right.forward();
	}
	
	public void right() {
		setSync(false);

		left.resetBlockTacho();
		right.resetBlockTacho();

		this.left.backward();
	}
	
	/**
	 * PRELIMINARY: Somewhat inaccurate at the moment.
	 * @param rotations
	 */
	public void left(long rotations) {
		left(rotations, false);
	}
	
	/**
	 * PRELIMINARY: Very inaccurate at the moment.
	 * @param rotations
	 * @param returnNow Returns immediately if true.
	 */
	public void left(long rotations, boolean returnNow) {
		setSync(false);

		left.resetBlockTacho();
		right.resetBlockTacho();
		left.resetRotationCounter();
		right.resetRotationCounter();
		
//		this.left.forward(rotations, true);
		this.right.forward(rotations, true);
		// Delay returning until done.
		if(!returnNow) {
//			while(Math.abs(left.getBlockTacho()) < rotations) {}
			//left.stop();
			while(Math.abs(right.getBlockTacho()) < rotations) {}
			//right.stop();
		}
	}
	
	/**
	 * PRELIMINARY: Somewhat inaccurate at the moment.
	 * @param rotations
	 */
	public void right(long rotations) {
		right(rotations, false);
	}
	
	/**
	 * PRELIMINARY: Very inaccurate at the moment.
	 * @param rotations
	 * @param returnNow Returns immediately if true.
	 */
	public void right(long rotations, boolean returnNow) {
		setSync(false);
		left.resetBlockTacho();
		right.resetBlockTacho();
		left.resetRotationCounter();
		right.resetRotationCounter();
		
		this.left.forward(rotations, true);
//		this.right.forward(rotations, true);
		// Delay returning until done.
		if(!returnNow) {
			while(Math.abs(left.getBlockTacho()) < rotations) {}
			//left.stop();
//			while(Math.abs(right.getBlockTacho()) < rotations) {}
			//right.stop();
		}
	}
	
	/**
	 * PRELIMINARY: Somewhat overshoots at the moment.
	 * @param rotations
	 */
	public void forward(long rotations) {
		setSync(true);
		left.resetBlockTacho();
		right.resetBlockTacho();
		left.turnRatio = 0;
		right.turnRatio = 0;
		if(inverted) {
			this.left.backward(rotations, true);
			this.right.backward(rotations, true);
		} else {
			this.left.forward(rotations, true);
			this.right.forward(rotations, true);
		}
		// Delay returning until done.
		while(Math.abs(left.getBlockTacho()) < rotations) {}
	}
	
	/**
	 * PRELIMINARY: Somewhat overshoots at the moment.
	 * @param rotations
	 */
	public void backward(long rotations) {
		setSync(true);
		left.resetBlockTacho();
		right.resetBlockTacho();
		left.turnRatio = 0;
		right.turnRatio = 0;
		if(inverted) {
			this.left.forward(rotations, true);
			this.right.forward(rotations, true);
		} else {	
			this.left.backward(rotations, true);
			this.right.backward(rotations, true);
		}
		while(Math.abs(left.getBlockTacho()) < rotations) {}
	}
	
	public void stop() {
		setSync(false);
		this.left.stop();
		this.right.stop();
	}
	
	public void flt() {
		setSync(false);
		this.left.flt();
		this.right.flt();
	}
}
